﻿// KeepNumbersAsConditionalText.jsx

/*
В выделенной области ищутся номера в начале абзаца.
Формат номеров 1, 2, 3 или с точками 2.4, 5.9 -- не важно.
Первым знаком должна быть цифра, поиск до первой буквы.
Найденные номера оформляются как условный текст. 

Если этот текст с такими намерами оформить абзацным стилем с установленной числовой нумерацией,
панель "Маркеры и нумерация", то это не повлияет на результат работы этого скрипта.

https://dotextok.ru
*/

app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll; // см. http://adobeindesign.ru/2008/10/24/restore-ui/

///////////////

var ProgressBar = function(title) { // ProgressBar
var w = new Window('palette', title, {x:0, y:0, width:840, height:60},{closeButton: true}),
pb = w.add('progressbar', {x:20, y:32, width:800, height:12}),
st = w.add('statictext', {x:20, y:12, width:800, height:20});
st.justify = 'left';
w.center();
this.reset = function(msg,maxValue) {
st.text = msg;
pb.value = 0;
pb.maxvalue = maxValue;
w.show();
w.update();
}
this.info = function(msg) {
  st.text = msg;
  w.show();
  w.update();
}
this.hit = function() {++pb.value; w.update();}
this.hide = function() {w.hide();}
this.close = function() {w.close();}
} // ProgressBar
////////////////////////////

var programTitul = "Номера -> условный текст";
if(app.documents.length == 0) {
    alert("Нет открытого документа.", programTitul);	
    exit();    
    }
var theCondition = [];
var nameOfCondition = "Скрытый номер";
try{ 
    app.activeDocument.conditions.add({name:nameOfCondition, indicatorColor:UIColors.GOLD, /* indicatorMethod:ConditionIndicatorMethod.USE_HIGHLIGHT,*/ visible:false}); 
    } 
catch(e) {  }
theCondition.push(app.activeDocument.conditions.item(nameOfCondition));
var sel = app.selection[0];
if ((sel == null) || ( sel.constructor.name != "Paragraph" && sel.constructor.name != "Text" && sel.constructor.name != "TextColumn" && sel.constructor.name != "TextStyleRange")) { // == null
    alert("Выделите область, в которой номера в начале абзацев надо оформить как условный текст.",programTitul);
    exit(); 
    } // == null
// расширим выделенную область до кратности абзацам
var sel = app.selection[0];
var myStartOfFragment = sel.paragraphs[0].characters.firstItem().index;
var myEndOfFragment = sel.paragraphs[sel.paragraphs.length - 1].characters.lastItem().index;
sel.parent.characters.itemByRange(myStartOfFragment,myEndOfFragment).select();
sel = app.selection[0];
app.findGrepPreferences = null; 
app.changeGrepPreferences = null;
app.findGrepPreferences.findWhat = "(^[\\.\\h\\d]+)(?=[\\u\\l])"; 
var rez = sel.texts[0].findGrep();
app.findGrepPreferences = null; 
app.changeGrepPreferences = null;
if (rez.length == 0) {
    alert("Ничего не найдено.", programTitul);	
    exit();    
    }
app.doScript(numAction, ScriptLanguage.JAVASCRIPT, [], UndoModes.FAST_ENTIRE_SCRIPT, 'numAction'); 
exit();
////////////////
function numAction() { // numAction
var rezLength = rez.length;
var pBar = new ProgressBar(programTitul); 
pBar.reset("Найденные номера оформляются как условный текст. Движение от конца к началу", rezLength);
for (p = rezLength-1; p >= 0; p--, pBar.hit()) { // p--
    rez[p].select();
    app.selection[0].applyConditions(theCondition, true);    
    } // p--
pBar.close();
return;
} // numAction
